POJ 3126 Prime Path(bfs+素数打表)

Prime Path

Time Limit: 1000MS


Memory Limit: 65536K

Total Submissions: 15098


Accepted: 8502

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0



题意:给出两个素四位数n,m。每次能改变n的一位数,且改变后仍是四位素数,问最少经过几次能让n变成m。不能变成m,输出-1.


题解:枚举n的每一位数的变化,符合要求的数入队列,记录每个数从n变化来的次数,直到变成m。


具体代码如下:


#include<cstdio>
#include<cstring>
#include<queue>
#include<algorithm>
#define maxn 10010
using namespace std;
int prime[maxn]={1,1};

void primes()//素数打表,值为0的下标为素数
{
	int i,j;
	for(i=2;i*i<=maxn;++i)
	{
		if(prime[i])
			continue;
		for(j=i*i;j<maxn;j+=i)
			prime[j]=1;
	}
}

void bfs(int n,int m)
{
	int mark[maxn],step[maxn];
	int num[4],x,i,j,temp;
	memset(mark,0,sizeof(mark));
	memset(step,0,sizeof(step));
	queue<int>q;
	q.push(n);
	mark[n]=1;
	while(!q.empty())
	{
		x=q.front();
		q.pop();
		if(x==m)//可能n与m相等 
		{
			printf("%d\n",step[x]);
			return ;
		}
		num[0]=x/1000;
		num[1]=x%1000/100;
		num[2]=x%100/10;
		num[3]=x%10;
		for(i=0;i<4;++i)
		{
			int t=num[i];
			for(j=0;j<10;++j)
			{
				if(i==0&&j==0)//四位数,第一位不等于0 
					continue;
				if(i==3&&j%2==0)//素数最后一位不能为偶数 
					continue; 
				if(t!=j)
				{
					num[i]=j;
					temp=num[0]*1000+num[1]*100+num[2]*10+num[3];
					if(!mark[temp]&&!prime[temp])
					{
						step[temp]=step[x]+1;
						mark[temp]=1;
						q.push(temp);
					}
				}
				if(temp==m)
				{
					printf("%d\n",step[temp]);
					return ;
				}
			}
			num[i]=t;
		}
	}
	printf("-1\n");
}

int main()
{
	primes();
	int n,m,i,t;
	scanf("%d",&t);
	while(t--)
	{
		scanf("%d%d",&n,&m);
		bfs(n,m);
	}
	return 0;
}




评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值